<?php

namespace Drupal\Tests\interactive_queue_processing\Functional;

use Drupal\Tests\BrowserTestBase;
use Drupal\user\Entity\Role;

/**
 * Base functionality for functional tests.
 */
abstract class InteractiveQueueProcessingBrowserTestBase extends BrowserTestBase {

  protected $defaultTheme = 'stark';

  protected static $modules = ['interactive_queue_processing_test'];

  /**
   * Add permission to anonymous user to allow them to process queues.
   */
  protected function allowAnonProcessing() {
    $role = Role::load('anonymous');
    $role->grantPermission('interactively process queues');
    $role->save();
  }

  /**
   * Processes the queues via AJAX endpoint.
   */
  protected function processQueues() {
    $this->drupalGet('interactive-queue-processing/ajax');
    $this->assertSession()->statusCodeEquals(200);
  }

}
